﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using DataDynamics.Analysis.Schema;
using System.Data;
using System.IO;
namespace WebApplication3
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void PivotView1_Load(object sender, EventArgs e)
        {
            
            RdDataSource1.ConnectionType = DataDynamics.Analysis.DataSources.ConnectionType.Sql;
            RdDataSource1.ConnectionString = ConnectionStringRelational;
            RdDataSource1.QueryString = QueryString;
            RdDataSource1.CustomSchemaFile = GenerateRelationalSchema(QueryString, ConnectionStringRelational);
             // Installs data source
            PivotView1.DataSourceID = "RdDataSource1";

        }

        private static string GenerateRelationalSchema(string queryString, string connectionString)
        {
            // Create schema for data source
            SchemaBuilder builder;
            using (IDbConnection connection = new System.Data.SqlClient.SqlConnection(connectionString))
                builder = SchemaBuilder.AutoGenerate("AutoGeneratedSchema", connection, queryString);

            // Save schema to file
            string schemaFile = Path.GetTempFileName();
            builder.SaveSchema(new FileInfo(schemaFile));

            
           
            return schemaFile;
        }

        private static string ConnectionStringRelational
        {
            //Please change the server name and credentials in the below Connection String
            get { return @"data source=IN-TS-AASHISH\SQLEXPRESS;initial catalog=Northwind;integrated security=SSPI;persist security info=False"; }
        }

        private const string QueryString =
                   @"SELECT c.CategoryName, p.ProductName, o.OrderID, o.OrderDate, d.UnitPrice, d.Quantity, s.Country AS SupplierCountry,
					s.City AS SupplierCity, s.CompanyName AS SupplierCompany, m.Country AS CustomerCountry, m.City AS CustomerCity,
					m.CompanyName AS CustomerCompany, d.Discount, m.Region AS CustomerRegion, s.Region AS SupplierRegion, e.LastName,
					e.EmployeeID AS EmployeeID, e.Title AS EmployeeTitle, e.Region AS EmployeeRegion, e.Country AS EmployeeCountry,
					e.City AS EmployeeCity, o.Freight, o.ShipName, o.ShipVia, o.ShipCity, o.ShipRegion, o.ShipCountry
					FROM Suppliers AS s INNER JOIN ((Categories AS c INNER JOIN Products AS p ON c.CategoryID = p.CategoryID)
					INNER JOIN (Employees AS e INNER JOIN (Customers AS m INNER JOIN (Orders AS o INNER JOIN [Order Details] AS d
					ON (o.OrderID = d.OrderID) AND (o.OrderID = d.OrderID) AND (o.OrderID = d.OrderID)) ON m.CustomerID = o.CustomerID)
					ON e.EmployeeID = o.EmployeeID) ON p.ProductID = d.ProductID) ON s.SupplierID = p.SupplierID";
    }
}
